//------------------------------------------------------------------------------------------------


//
// File: main.cpp
// Author: Roman Lysecky
// Date Created: 28 November 2011
// 
// Copyright: Roman Lysecky, Electrical and Computer Engineering, University of Arizona, 2011.
// 
//

//------------------------------------------------------------------------------------------------

#include "linesegment.h"
#include "polygon.h"
#include <iostream>

//------------------------------------------------------------------------------------------------

using namespace std;

//------------------------------------------------------------------------------------------------

int 
main() 
{
    Polygon polygon1;
    
    // This is not a *good* method for catching exceptions, but it will illustrate
    // the basic idea.
    try {
        polygon1.insert_segment((char *)"a", 0, 0, 0, 5);
        polygon1.insert_segment((char *)"b", 5, 5, 0, 5);
        polygon1.insert_segment((char *)"c", 5, 5, 5, 0);
        polygon1.insert_segment((char *)"d", 5, 0, 0, 0);
    }
    catch (exception& e) {
        // Let's print to cerr to illustrate how this works.
        cerr << "Exception: " << e.what() << ", exiting program." << endl;
        return -1;
    }
           
    cout << "UNSORTED: " << polygon1 << endl;
        
    // sort the polygon's list of line segments
    polygon1.segments.sort();
    cout << "SORTED:   " << polygon1 << endl;

    cout << flush;
    
    return 0;
}

//------------------------------------------------------------------------------------------------

